package cn.wch.ch934xuartdemo.ui;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.view.View.OnClickListener;

import androidx.annotation.Nullable;
import androidx.appcompat.widget.AppCompatCheckBox;

public class MyCheckBox extends AppCompatCheckBox {

    private MonitorState monitorState;

    public MyCheckBox(Context context) {
        super(context);
    }

    public MyCheckBox(Context context, AttributeSet attrs) {
        super(context, attrs);
        init();
    }

    public MyCheckBox(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }


    void init(){

        setOnClickListener(clickListener);
    }

    private OnClickListener clickListener=new OnClickListener() {
        @Override
        public void onClick(View v) {
            if(monitorState!=null){
                monitorState.onWishStatus(isChecked());
            }
        }
    };



   public void setState(boolean checked){
       setChecked(checked);
   }

    public void setMonitorListener(MonitorState monitorListener){
        this.monitorState=monitorListener;
    }

    public interface MonitorState{
        void onWishStatus(boolean checked);
    }
}
