package cn.wch.ch934xuartdemo.ui;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;

import androidx.appcompat.widget.AppCompatRadioButton;

import cn.wch.ch934xuartdemo.utils.LogUtil;

public class MyRadioButton extends AppCompatRadioButton {

    private OnCheckListener listener;
    private boolean intercept=false;

    public MyRadioButton(Context context) {
        super(context);
    }

    public MyRadioButton(Context context, AttributeSet attrs) {
        super(context, attrs);
        init();
    }

    public MyRadioButton(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    void init(){

        setOnCheckedChangeListener(checkedChangeListener);
    }

    private OnCheckedChangeListener checkedChangeListener=new OnCheckedChangeListener() {
        @Override
        public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {

            LogUtil.d("check: "+buttonView.getId()+isChecked);
            if(intercept){
                LogUtil.d("check: intercept");
                intercept=false;
                return;
            }

            if(!isChecked){
                LogUtil.d("check: false");
                return;
            }

            if(listener!=null){
                listener.onChecked();
            }
            LogUtil.d("check: end");
        }
    };

    public void setCheckStatusWithoutCallback(boolean checked){
        intercept=true;
        setChecked(checked);
    }

    public void setListener(OnCheckListener listener){
        this.listener=listener;
    }

    public static interface OnCheckListener{
        void onChecked();
    }
}
